(* ------------------------------------------------------ *)
(*                   ENVDEMO.PAS                          *)
(*    Demonstration zur Verwendung von DOS-Umgebungs-     *)
(*    variablen in Turbo Viernull. Vgl.: PASCAL 12/87     *)
(* ------------------------------------------------------ *)

PROGRAM Envdemo;

USES Environ;

VAR f         : FILE;
    FileExists: BOOLEAN;
    p         : BYTE;
    DosPath,
    SearchPath,
    SearchName,
    FileName  : STRING;

BEGIN
  WriteLn; WriteLn;
  Write('Bitte einen Dateinamen (ohne Pfad) eingeben: ');
  ReadLn(FileName);
  SearchPath := '';
  DosPath := ';'+ EnvVar('PATH');
  WriteLn(DosPath);
  REPEAT
    p := Pos(';', DosPath);
    IF p = 0 THEN p := Succ(Length(DosPath));
    SearchPath := Copy(DosPath, 1, Pred(p));
    Delete(DosPath, 1, p);
    IF SearchPath = '' THEN
      SearchName := FileName
    ELSE
      IF SearchPath[Length(SearchPath)] = '\' THEN
        SearchName := SearchPath + FileName
      ELSE
        SearchName := SearchPath + '\' + FileName;
    WriteLn('Suche ', SearchName, ' ...');
    Assign(f, SearchName);
    {$I-} Reset(f); close(f); {$I+}
    FileExists := (IOResult = 0);
  UNTIL FileExists OR (DosPath = '');
  WriteLn;
  IF FileExists THEN
    IF SearchPath = ''THEN
      WriteLn('Datei befindet sich im aktuellen Laufwerk!')
    ELSE
      WriteLn('Datei befindet sich im Verzeichnis ',
              SearchPath,'!')
  ELSE
    WriteLn('Datei nicht gefunden!');
END.

(* ------------------------------------------------------ *)
(*               Ende von ENVDEMO.PAS                     *)
